# std::ctype::scan_is, std::ctype::do_scan_is

From cppreference.com
< cpp‎ | locale‎ | ctype

Defined in header `<locale>` |  |
public: const CharT* scan_is( mask m, const CharT* beg, const CharT* end ) const; | (1) |
protected: virtual const CharT* do_scan_is( mask m, const CharT* beg, const CharT* end) const; | (2) |

1) public member function, calls the protected virtual member function `do_scan_is` of the most derived class.
2) Locates the first character in the character array `[beg, end)` that satisfies the classification mask `m`, that is, the first character `c` such that is(m, c) would return true.

### Parameters

m | - | mask to search for
beg | - | pointer to the first character in an array of characters to search
end | - | one past the end pointer for the array of characters to search

### Return value

Pointer to the first character in `[beg, end)` that satisfies the mask, or `end` if no such character was found.

### Example

Run this code

    #include <locale>
    #include <iostream>
    #include <iterator>

    int main()
    {
        auto& f = std::use_facet<std::ctype<char>>(std::locale(""));

        // skip until the first letter
        char s1[] = "      \t\t\n  Test";
        const char* p1 = f.scan_is(std::ctype_base::alpha, std::begin(s1), std::end(s1));
        std::cout << "'" << p1 << "'\n";

        // skip until the first letter
        char s2[] = "123456789abcd";
        const char* p2 = f.scan_is(std::ctype_base::alpha, std::begin(s2), std::end(s2));
        std::cout << "'" << p2 << "'\n";
    }

Output:

    'Test'
    'abcd'

### See also

do_scan_not [virtual] | locates the first character in a sequence that fails given classification (virtual protected member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/locale/ctype/scan_is&oldid=58096"